
import java.lang.*;
import java.util.*;

/**
* tree : can have multiple children of type Node 
*	this UI draw MTree, so you must create MTree to draw your tree on this
*	UI.
*	Any tree can be transformed to MTree.
*
* @author Joon-Myung Kang
* @version 0.5
* @since 1999/05/22
*/

public class MTree{
//multiple tree

	/**
	* root node
	*/
	Node root ;
	/**
	* height of tree
	*/
	int height = -1;
	/**
	* width of tree
	*/
	int width = -1; 

	/**
	* constructor.
	* create empty tree
	*
	* @param none
	* @return none
	*/
	public MTree(){
		height = 0;
	}

	/**
	* constructor.
	* create a tree with just root node.
	*
	* @param n root node
	* @return none
	*/
	public MTree( Node n ){
		height = 1;
		root = n;
	}

	/**
	* constructor.
	* create a tree with just root node of type String
	*
	* @param n root node of type String
	* @return none
	*/
	public MTree( String n  ){
		height = 1;
		root = new Node( n );
	}

	/**
	* get the root node.
	*
	* @param none
	* @return root node
	*/
	public Node getRoot(){ return root ; }

	/**
	* get the height of node.
	* 
	* @return height of node.
	*/
	public int getHeight(){ return height ;}

	/**
	* get the width of node.
	* 
	* @return width of node.
	*/
	public int getWidth(){ return width ;}

}
//end of file
