
import java.io.*;
import java.lang.*;
import java.net.*;

/**
* Html Parser , make parse tree for html syntax
*
* @author	Joon-Myung Kang
* @version	0.5
* @since	1999/05/22
*/

public class Parser
{
	String search;
	public boolean found;
	/**
	* Parse a web page.
	*
	* @param addr the web page address which will be parsed
	* @return none
	*/
	public Parser(String addr,String search)
	{
		found=false;
		this.search = search;
		URL url=null;

		try
		{
			url=new URL(addr);
		}
		catch(MalformedURLException e)
		{
			e.printStackTrace();
		}

		Tagtree t=new Tagtree(url);
		Node n=t.getRoot();

		parse(n);
	}

	public void parse(Node node)
	{
		Node parseNode=node;

		try
		{
			if(parseNode.getLabel().toUpperCase().indexOf(search.toUpperCase())!=-1)
			{
				found=true;
				return;
			}
		}
		catch(ArrayIndexOutOfBoundsException e)
		{
		}
		catch(StringIndexOutOfBoundsException e)
		{
		}

		for(int i=0;i<node.childSize();i++)
		{
			parse(node.getChildAt(i)) ;
		}
	}

	public static void main(String[] args)
	{
		Parser s=new Parser("http://ohhara.postech.ac.kr","haha");
		System.out.println(s.found);
	}
}
