/* **********************************************************************
 * jess.reflect.Canvas - A GUI adapter for Jess. Lets you do graphics
 * from Jess code!
 *
 * Construct one of these with the name of a 'painting' Userfunction as
 * the first argument (a deffunction, usually.) The function should expect a
 * Component as its first argument, and a java.awt.Graphics object
 * as its second argument (both as EXTERNAL_OBJECTs)
 *
 * (C) 1998 E.J. Friedman-Hill and the Sandia Corporation
 * $Id$
 ********************************************************************** */

package jess.reflect;
import jess.*;

public class Canvas extends java.awt.Canvas
{
  private Funcall m_fc;
  private Rete m_engine;

  public Canvas(String uf, Rete engine) throws ReteException
  {
    m_engine = engine;
    m_fc = new Funcall(uf, engine);
    m_fc.add(new Value(this, RU.EXTERNAL_ADDRESS));
    m_fc.setLength(3);
  }      

  public void paint(java.awt.Graphics g)
  {
    try
      {
        m_fc.set(new Value(g, RU.EXTERNAL_ADDRESS), 2);
        Funcall.simpleExecute(m_fc, m_engine.globalContext());
      }
    catch (ReteException re)
      {
        m_engine.errStream().println(re);
      }
  }
}
