/*
 * WebRobot.java
 *	Get contents of web pages to obtain intended informaion.
 *
 * This program is designed for CS571 Computer Graphics of POSTECH
 *
 * Copyright (c) Spring 1998, Dept of Computer Science & Engineering
 * Namgoong Jae-chang (sinclair@postech.ac.kr)
 *
 * $Id: WebRobot.java,v 1.3 1998/06/22 09:06:54 sinclair Exp $
 */

import java.net.*;
import java.io.*;
import java.util.Date;
import HTTPClient.*;
import com.sleepycat.db.*;
import URLDatabase;
import CDRecord;

public class WebRobot
{
    /*
     * Constructor
     */
    public WebRobot()
    {
	// URL DB Openϰ,  URL ִ´.
	String url = new String("http://www.emusic.com/graphics/search/stylesearch.cfm?type=2&key=new+age&hard=0&tempid=541547");
	saveURL(url);
    }

    /*
     * ð ִ Լ
     */
    public void elapseTime()
    {
	Date date = new Date();
	long time = date.getTime();

	time += 1000 * 15;	// 15
	date.setTime(time);

	System.out.println("Waiting for 15 seconds...");
	while (true) {
	    Date current = new Date();
	    if (current.after(date) == true)
		break;
	}
    }

    /*
     * Save URL to DB
     */
    public void saveURL(String url)
    {
	try {
	    String base = null;
	    URLDatabase urlDB = new URLDatabase(base);
	    System.out.println("Saving URL: " + url);
	    urlDB.save(url);
	}
	catch (DbException dbe) {
	    System.err.println("URLDatabase: " + dbe.toString());
	}
    }

    /*
     * Load URL from DB
     */
    public String loadURL()
    {
	String url = null;

	try {
	    String base = null;
	    URLDatabase urlDB = new URLDatabase(base);
	    url = urlDB.load();
	    System.out.println(" ");
	    System.out.println("Loading URL: " + url);
	}
	catch (DbException dbe) {
	    System.err.println("URLDatabase: " + dbe.toString());
	}

	return (url);
    }

    /*
     * Check URL not to visit later
     */
    public void checkURL(String url)
    {
	try {
	    String base = null;
	    URLDatabase urlDB = new URLDatabase(base);
	    urlDB.check(url);
	}
	catch (DbException dbe) {
	    System.err.println("URLDatabase: " + dbe.toString());
	}
    }

    /*
     * ־ URL Leaf nodeΰ ˷
     */
    public boolean isLeafNode(String url)
    {
	String str = url.toUpperCase();

	// CGI α׷  Ȯ
	if (str.indexOf("TITLE.CFM") != -1)
	    return true;
	else
	    return false;
    }

    /*
     * URL ȭ(normalization)ִ Լ
     */
    public String getNormalURL(String url)
    {
	int pos1, pos2;

	String link = url;
	String str = url.toUpperCase();

	// "cache_killer" ʵ 
	pos1 = str.indexOf("CACHE_KILLER");
	if (pos1 != -1) {
	    pos2 = str.indexOf("&", pos1);

	    if (pos2 != -1)
		link = url.substring(0, pos1) + url.substring(pos2+1);
	    else
		link = url.substring(0, pos1);
	}

	// ".." 
	pos2 = link.indexOf("/../");
	if (pos2 != -1) {
	    pos1 = link.lastIndexOf("/", pos2-1);
	    link = link.substring(0, pos1+1) + link.substring(pos2+4);
	}

	return new String(link);
    }

    /*
    public void findField(String str, int pos, Integer begin, Integer end)
    {
	do {
	    begin = (Integer) str.indexOf(">", pos);
	    pos = begin.intValue() + 1;
	    end = new Integer(str.indexOf("<", pos));
	} while (pos == end.intValue());
    }
    */

    /*
     * Leaf node ؼ  ϴ Լ
     */
    public void parseContents(String arg, String url)
    {
	int pos1, pos2, pos3;
	String artist, title, date, price, sales, critics, label;

	//  
	String str = arg.toUpperCase();

	pos1 = str.indexOf("/ARTIST.CFM");
	if (pos1 == -1) return;
	do {
	    pos2 = str.indexOf(">", pos1);
	    pos1 = pos2 + 1;
	    pos3 = str.indexOf("<", pos1);
	} while (pos1 == pos3);
	artist = str.substring(pos2+1, pos3);

	pos1 = str.indexOf("<FONT", pos3);
	do {
	    pos2 = str.indexOf(">", pos1);
	    pos1 = pos2 + 1;
	    pos3 = str.indexOf("<", pos1);
	} while (pos1 == pos3);
	title = str.substring(pos2+1, pos3);

	pos1 = str.indexOf("RELEASE DATE:", pos3);
	pos1 = str.indexOf("<FONT", pos1);
	do {
	    pos2 = str.indexOf(">", pos1);
	    pos1 = pos2 + 1;
	    pos3 = str.indexOf("<", pos1);
	} while (pos1 == pos3);
	date = str.substring(pos2+1, pos3);

	pos1 = str.indexOf("PRICE:", pos3);
	pos1 = str.indexOf("<FONT", pos1);
	do {
	    pos2 = str.indexOf(">", pos1);
	    pos1 = pos2 + 1;
	    pos3 = str.indexOf("<", pos1);
	} while (pos1 == pos3);
	price = str.substring(pos2+2, pos3);

	pos1 = str.indexOf("SALES RATING:", pos3);
	pos1 = str.indexOf("<FONT", pos1);
	do {
	    pos2 = str.indexOf(">", pos1);
	    pos1 = pos2 + 1;
	    pos3 = str.indexOf("<", pos1);
	} while (pos1 == pos3);
	sales = (new Integer(str.substring(pos2+1, pos3).length())).toString();

	pos1 = str.indexOf("CRITICS RATING:", pos3);
	pos1 = str.indexOf("<FONT", pos1);
	do {
	    pos2 = str.indexOf(">", pos1);
	    pos1 = pos2 + 1;
	    pos3 = str.indexOf("<", pos1);
	} while (pos1 == pos3);
	critics = (new Integer(str.substring(pos2+1, pos3).length())).toString();

	pos1 = str.indexOf("LABEL:", pos3);
	pos1 = str.indexOf("<FONT", pos1);
	do {
	    pos2 = str.indexOf(">", pos1);
	    pos1 = pos2 + 1;
	    pos3 = str.indexOf("<", pos1);
	} while (pos1 == pos3);
	label = str.substring(pos2+1, pos3);

	// !Test!
	System.out.println(" ");
	System.out.println("Artist: " + artist);
	System.out.println("Title: " + title);
	System.out.println("Date: " + date);
	System.out.println("Price: " + price);
	System.out.println("Label: " + label);
	System.out.println("Sales Rating: " + sales);
	System.out.println("Critics Rating: " + critics);

	//   Index DB 
	CDRecord.Insert(date, label, title, artist, price, sales, critics, url);
    }

    /*
     * Inner node Ͽ URLs ϴ Լ
     */
    public void extractURLs(String arg)
    {
	int pos1, pos2, pos3, pos4;
	String link, newLink;

	String str = arg.toUpperCase();

	while (true) {
	    pos1 = str.lastIndexOf("TITLE.CFM");
	    pos2 = str.lastIndexOf("STYLESEARCH.CFM");

	    if ((pos1 == -1) && (pos2 == -1))
		break;

	    else {
		// Leaf node URL 
		if (pos1 > pos2) {
		    pos3 = str.lastIndexOf("\"", pos1);
		    pos4 = str.indexOf("\"", pos1);
		}

		// Inner node URL 
		else {
		    pos3 = str.lastIndexOf("\"", pos2);
		    pos4 = str.indexOf("\"", pos2);
		}

		pos3 += 1;
		link = arg.substring(pos3, pos4);

		//  URL ƴ  URL ٲ
		if (link.indexOf(":") != -1)
		    newLink = link;
		else
		    newLink = new String("http://www.emusic.com/graphics/search/" + link);

		// Normalization of URLs & Save it to URL DB
		saveURL(getNormalURL(newLink));

		str = str.substring(0, pos3);
	    }
	}
    }

    /*
     * Target Ʈ ؼ   Լ
     */
    public void simpleConnection(URL url)
    {
	try {
	    System.out.println(" ");
	    System.out.println("Trying to connect...");

	    HTTPConnection con = new HTTPConnection(url);
	    HTTPResponse rsp = con.Get(url.getFile());

	    if (rsp.getStatusCode() >= 300) {
		System.err.println("Recieved Error: " + rsp.getReasonLine());
		System.err.println(new String(rsp.getData()));
	    }
	    else {
		// check a visited link not to visit later
		checkURL(url.toString());
		System.out.println("Successfully connected.");

		String data = new String(rsp.getData());

		if (isLeafNode(url.getFile())) {
		    //  Parsing
		    parseContents(data, url.toString());
		}
		else {
		    // URL ؼ URL DB 
		    extractURLs(data);
		}
	    }
	}
	catch (IOException ioe) {
	    System.err.println(ioe.toString());
	}
	catch (ModuleException me) {
	    System.err.println("Error handling request: " + me.getMessage());
	}
    }

    /*
     *   Web Robot  ưԲ ϴ Լ
     */
    public void run()
    {
	/*
	try {
	    String base = null;
	    URLDatabase urlDB = new URLDatabase(base);
	    urlDB.print();
	}
	catch (DbException dbe) {
	    System.err.println("URLDatabase: " + dbe.toString());
	}
	*/

	while (true) {
	    // URL DB URL ϳ оδ.
	    String url = loadURL();

	    //  ϸ ̱  ð ణ üŲ.
	    elapseTime();

	    //  visited URL̶ exit
	    if (url.equals(null) == true)
		break;

	    //  õ
	    try {
		simpleConnection(new URL(url));
	    }
	    catch (MalformedURLException e) {
		System.err.println("URL: " + e.toString());
	    }
	}
    }

    /*
     * Main Function
     */
    public static void main(String args[])
    {
	// κ νϽȭ
	WebRobot myRobot = new WebRobot();
	myRobot.run();
    }
}
